/*************************************************
 gb/gbc rom dump script
 support gameboy nintendo power
*************************************************/
function np_write_cmd(d,cmd)
{
  switch (cmd) {
    case 0x01:
      cpu_write(d,0x0120, 0x01);
      cpu_write(d,0x013F, 0xA5);
      break;

    case 0x02:
      cpu_write(d,0x0120, 0x02);
      cpu_write(d,0x013F, 0xA5);
      break;

    case 0x03:
      cpu_write(d,0x0120, 0x03);
      cpu_write(d,0x013F, 0xA5);
      break;

    case 0x04:
      cpu_write(d,0x0120, 0x04);
      cpu_write(d,0x013F, 0xA5);
      break;

    case 0x05:
      cpu_write(d,0x0120, 0x05);
      cpu_write(d,0x013F, 0xA5);
      break;

    case 0x08:
      cpu_write(d,0x0120, 0x08);
      cpu_write(d,0x013F, 0xA5);
      break;

    case 0x09:
      cpu_write(d,0x0120, 0x09);
      cpu_write(d,0x0121, 0xAA);
      cpu_write(d,0x0122, 0x55);
      cpu_write(d,0x013F, 0xA5);
      break;

    case 0x0A:
      cpu_write(d,0x0120, 0x0A);
      cpu_write(d,0x0125, 0x62);
      cpu_write(d,0x0126, 0x04);
      cpu_write(d,0x013F, 0xA5);
      break;

    case 0x10:
      cpu_write(d,0x0120, 0x10);
      cpu_write(d,0x013F, 0xA5);
      break;

    case 0x11:
      cpu_write(d,0x0120, 0x11);
      cpu_write(d,0x013F, 0xA5);
      break;
  }
}

function cpu_dump(d, rom_size, banksize)
{
	if(rom_size==0x100000)//np
	{
		np_write_cmd(d, 9);	
		np_write_cmd(d, 4);	
		np_write_cmd(d, 8);	
	}
		
	cpu_read (d, 0x0000, 0x4000); 
	for(local i = 1; i < rom_size/0x4000; i += 1)
	{
		//cpu_write(d, 0x3000, i>>8);
		//cpu_write(d, 0x2000, i&0xFF);
		cpu_write(d, 0x3000, i>>8, 0x2100, i&0xFF);
		cpu_read (d, 0x4000, 0x4000); 
	}
}

function cpu_erase(d, rom_size, flash_chip_type)
{
	local m_29f_flash = 0;
	local m_29lv_flash = 1;
	
	//local flash_chip_type = m_29lv_flash;
	//change to m_29f_flash here, if your gb 
	//flash chip is 29f(mx29f016,amd29f016,amd29f080...)
	
	//detect chip here
	if(flash_chip_type==m_29f_flash)
	{
		cpu_write(d,0x555,0xF0);

		cpu_write(d,0x555,0xAA);
		cpu_write(d,0x2AA,0x55);
		cpu_write(d,0x555,0x80);

		cpu_write(d,0x555,0xAA);
		cpu_write(d,0x2AA,0x55);
		cpu_write(d,0x555,0x10);
	}
	else{
	//erase mx29lv320 
	cpu_write(d,0xAAA,0xF0);

	cpu_write(d,0xAAA,0xAA);
	cpu_write(d,0x555,0x55);
	cpu_write(d,0xAAA,0x80);
	cpu_write(d,0xAAA,0xAA);
	cpu_write(d,0x555,0x55);
	cpu_write(d,0xAAA,0x10);	
	}
	rom_flash_cfg(d,flash_chip_type);
}
function cpu_flash(d, rom_size, banksize)
{
	if(rom_size==0x4000) rom_write (d, 0x0000, 0x4000);
	else rom_write (d, 0x4000, 0x4000);
}
function save_dump(d, save_size, max_size)
{
	//direct read
	cpu_read (d, 0xA000, 0x2000);
}
function save_erase(d, save_size, max_size)
{
	//not need here
}
function save_write(d, save_size, max_size)
{
	//direct write
	ram_write(d, 0xA000, 0x2000);
}
